#include "Interleaver.h"
#include <string>
#include <iostream>
#include <iomanip>
#include <unistd.h>
#include <stdio.h>
#include <stdint.h>

void FillInterleaver(char* values, int valuesLength, char* buffer, int height, int width)

{
        // Move all the values

        for (int i = height * width - valuesLength - 1; i >= 0; i--)

        {

                // Move element i to element i+valuesLength

                buffer[i + valuesLength] = buffer[i];

        }

        // Add the new values

        for (int i = 0; i < valuesLength; i++)

        {

                // Copy from values to buffer

                buffer[i] = values[i];

        }

}



/*Converts the input buffer to an interleaved array*/

char* Interleave(char* buffer, int height, int width)

{

        // Initialize a new array for the output
        char* result = new char[height*width]();

	for(int i=0;i<height*width;i++)
		result[i]=0x0;



        // Set the index to 0

        int indexInOutput = 0;



        // The bit of the next char

        int bitNrInOuptut = 7;



        char tempChar = 0x0;



        // For each column

        for (int col = 0; col < width; col++)
        {
                // For each bit in the column (sub-column)

                for (int bitNumber = 7; bitNumber >= 0; bitNumber--)
                {
                        // The mask for the sub-column

                        uint8_t Mask = 0x01 << bitNumber;


                        // For each row

                        for (int row = 0; row < height; row++)
                        {

                                // Get the bit from the cell

                                uint8_t bitValue = buffer[row*width + col] & Mask;



                                // Calculate the amount of shift, pos is to the left, neg is to the right

                                int bitShiftAmount = bitNrInOuptut - bitNumber;



                                // If the shift is to the left

                                if (bitShiftAmount > 0){

                                        // Shift to the left

                                        bitValue = bitValue << bitShiftAmount;}



                                else if (bitShiftAmount < 0)

                                {

                                        // Change the sign

                                        bitShiftAmount = bitShiftAmount * -1;

                                        // Shift to the right

                                        bitValue = bitValue >> bitShiftAmount;

                                }



                                // The bit is now on the correct position

                                // OR it with the previous values

                                tempChar = tempChar | bitValue;



                                // Go to next position in output

                                bitNrInOuptut--;



                                // If the next position is in the next character

                                if (bitNrInOuptut == -1)

                                {

                                        // Reset the bitnr in the output

                                        bitNrInOuptut = 7;



                                        // Set the next output value

                                        result[indexInOutput] = tempChar;



                                        // Go to the next position

                                        indexInOutput++;



                                        // Reset the temp char

                                        tempChar = 0x0;

                                }

                        }

                }

        }

        // Return the result

        return result;

}



/*Converts the input buffer to an de-interleaved array*/

char* DeInterleave(char* buffer, int height, int width)

{

        // Initialize a new array for the output (and make sure all the values are 0)

        char* result = new char[height*width]();

	for(int i=0;i<height*width;i++)
		result[i]=0x0;


        // For each char in the result

        for (int index = 0; index < height*width; index++)

        {

                // Calculate the column number

                int columnNr = index % width;



                // Calculate the row number

                int rowNr = index / width;



                // Calculate the position of the first bit

                int bitOffset = columnNr * height * 8 + rowNr;



                // For each bit of the character in the result

                for (int bitNr = 0; bitNr < 8; bitNr++)

                {

                        // There are height bits between two bits of a char

                        // So the bit is at position bitOffset + height*bitNr

                        int bitPosition = bitOffset + height * bitNr;



                        // Get the byte number from the bit number

                        int byteNr = bitPosition / 8;



                        // Get the offset in the mask

                        int maskOffset = bitPosition % 8;



                        // Generate the mask

                        uint8_t mask = 0x80 >> maskOffset;



                        // Get the bit

                        uint8_t bitValue = buffer[byteNr] & mask;



                        // Shift it to the first position

                        bitValue = bitValue >> (7 - maskOffset);



                        // Shift it from the first position to its final position

                        bitValue = bitValue << (7 - bitNr);



                        // Add it to the result

                        result[index] = result[index] | bitValue;

                }

        }



        // Return the result

        return result;

}
